#(c)www.stani.be
import blenpy
INFO=blenpy.INFO.copy()

INFO['description']=\
"""Tools are programs, which run externally from blenpy. The following keys are
already taken for shortcuts:
    A,B,E,R,S,ENTER+C,D,F,G,H,I,J,L,M,N,O,P,T,W,X,Y,Z
Customize this file if you want to add your own tools, and share it with other
users by emailing it back."""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

#---Import Modules--------------------------------------------------------------
import os,sys,blenpy,webbrowser
BLENPY_PATH=os.path.dirname(blenpy.__file__)
#---Tools: add your own---------------------------------------------------------
def Spe(keyDown=0):
    """Spe @W

    Python IDE, specially designed for
    Blender, with a Blender browser,
    class/method browser,auto todo list,
    auto index,interactive shell,locals
    browser and so on...
    *
    Requires: wxPython
    http://www.wxpython.org
    http://www.stani.be
    """
    try:
        import spe
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:spe.main()


if blenpy.pyGui.extEditors.has_key('Boa'):
    def boa(keyDown=0):
        """Boa Constructor (wx)@C

        Visual editor for Python applications
        (like Delphi) with excellent support
        for dialogs.
        *
        Requires: wxPython
        http://boa.sourceforge.net
        http://www.wxpython.org
        """
        if not keyDown:
            boaPath=os.path.dirname(blenpy.pyGui.extEditors['Boa'].editor[2])
            previous=sys.path
            if boaPath not in sys.path:sys.path=[boaPath]+sys.path
            try:
                import Boa
                Boa.main()
            except:
                print "Error: Unable to start boa."
            sys.path=previous

def help(keyDown=0):
    """Blenpy Help@G"""
    # TODO:launchHelp
    if not keyDown:webbrowser.open('file://%s/doc/help.html'%BLENPY_PATH,1)

def blenpyApi(keyDown=0):
    """Blenpy API Help@F"""
    # TODO:launchApi
    if not keyDown:webbrowser.open('file://%s/doc/blenpy.html'%BLENPY_PATH,1)

def helpApi(keyDown=0):
    """Blender Python API Help@H"""
    # TODO:launchApi
    if not keyDown:webbrowser.open('file://%s/doc/Blender.html'%BLENPY_PATH,1)

def idle(keyDown=0):
    """Idle Shell (Tk)@T

    Interactive Python Shell with
    Class browser.
    *
    Requires:Tkinter,PyShell
    """
    import sm.tk as tk
    try:
        import sm.tk as tk
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:tk.idle()

def inspectorBl(keyDown=0):
    """Inspector (Tk)@I

    Inspects all the available Blender
    Python information of the drawing
    such as objects,cameras,lamps...
    *
    Requires:Tkinter,ObjectBrowser
    """
    try:
        import blenpy.pyGui
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:blenpy.pyGui.inspectorBlender(recursive=0)

def inspectorBlSilver(keyDown=0):
    """Inspector >>> (Tk)@J

    Inspects all the available Blender
    Python information of the drawing
    such as objects,cameras,lamps...
    and executes all get* methods.
    *
    Requires:Tkinter,ObjectBrowser
    """
    try:
        import blenpy.pyGui
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:blenpy.pyGui.inspectorBlender()

if blenpy.pyGui.extEditors.has_key('Leo'):
    def leo(keyDown=0):
        """Leo (Tk)@L

        Leo is a programmer's editor, an
        outlining editor, a flexible browser
        and a literate programming tool,
        compatible with noweb and CWEB.
        It will open the 'blender.leo' file
        from the 'blenpy\plugins' path.
        *
        Requires: Leo,Tkinter
        http://sourceforge.net/projects/leo
        """
        if not keyDown:
            leoPath=os.path.dirname(blenpy.pyGui.extEditors['Leo'].editor[2])
            previous=sys.path
            if leoPath not in sys.path:sys.path=[leoPath]+sys.path
            try:
                import Leo.leo
                Leo.leo.leoOpen(os.path.join(BLENPY_PATH,'plugins','blender.leo'))
            except:
                print "Error: Unable to start Leo."
            sys.path=previous

def pyCrust(keyDown=0):
    """PyCrust Light (wx)@M

    Launches PyCrust, an interactive
    shell with a locals() objects
    browser.
    *
    Requires:wxPython
    http://www.wxpython.org
    """
    try:
        import blenpy.pyGui
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:blenpy.pyGui.blenderCrust(blenderImport=0,tab=0)

def pyCrustSilver(keyDown=0):
    """PyCrust (wx)@N

    Launches PyCrust, an interactive
    shell with a locals() objects
    browser and tabs for all the
    Blender data (objects,cameras...)
    *
    Requires:wxPython
    http://www.wxpython.org
    """
    if not keyDown:blenpy.pyGui.blenderCrust(recursive=0)

def pyCrustGold(keyDown=0):
    """PyCrust >>> (wx)@O

    Launches PyCrust, an interactive
    shell with a locals() objects
    browser and tabs for all the
    Blender data (objects,cameras...)
    of which the return values of their
    get methods are also included.
    *
    Requires:wxPython
    Url:www.wxpython.org
    """
    if not keyDown:blenpy.pyGui.blenderCrust()

def pyDoc(keyDown=0):
    """PyDoc (very crashy!)@D

    Launches pydoc which can search
    through all the documentation of
    installed modules on your computer.

    Blender will crash afterwards, so
    only use it if you really need it.
    """
    try:
        import pydoc
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    if not keyDown:pydoc.gui()

if blenpy.pyGui.extEditors.has_key('PythonWin'):
    def blenderPythonWin(fileName=None):
        """PythonWin Light@X"""
        try:
            import Blender,blenpy.plugins,sm.win,os
        except ImportError,message:
            print message
            return
        sm.win.PythonWinPreload(\
            fileName=fileName,
            path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                'PythonWinFiles.txt'),
            modules='Blender',
            statusText='blenpy - www.stani.be'
        )

    def blenderPythonWinSilver(fileName=None):
        """PythonWin@Y"""
        try:
            import Blender,blenpy.plugins,sm.win,os
        except ImportError,message:
            print message
            return
        sm.win.PythonWinPreload(\
            fileName=fileName,
            path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                'PythonWinFiles.txt'),
            browse=[(Blender,'Blender Module - blenpy')],
            modules='Blender',
            statusText='blenpy - www.stani.be',
        )

    def blenderPythonWinGold(fileName=None):
        """PythonWin >>>@Z"""
        try:
            import Blender,blenpy.plugins,sm.win,os,blenpy.pyGui
        except ImportError,message:
            print message
            return
        inspect=blenpy.pyGui.inspect()
        sm.win.PythonWinPreload(\
            fileName=fileName,
            path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                'PythonWinFiles.txt'),
            browse=[(inspect,'>>> - blenpy')],
            modules='blenpy.plugins.all',
            statusText='blenpy - www.stani.be'
        )

#