#(c)www.stani.be (read __doc__ for more information)
import sm
INFO=sm.INFO.copy()

INFO['description']=\
"""Windows specific"""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

def Browse (ob,title='Python Object Browser'):
    " Browse the argument, or the main dictionary "
    import pywin.tools.browser as b
    class dynamic_browser(b.dynamic_browser):
        def __init__(self,hli_root,title='Python Object Browser'):
            self.dt[0][0]=title
            b.dynamic_browser.__init__(self,hli_root)
    root = b.MakeHLI (ob, 'root')
    if not root.IsExpandable():
        raise TypeError, "Browse() argument must have __dict__ attribute, or be a Browser supported type"
    dlg = dynamic_browser (root,title=title)
    dlg.CreateWindow()

class PythonWin:
    """PythonWin IDE as a Class"""
    def __init__(self,fileName=None,browse=[],browseMDI=[],modules='',fileList=[],onIdle=None):
        """Constructor
        BrowseMDIs: objects to be opened in a browser window
        fileList:   list of files to be preloaded
        """
        try:
            import os,sys
            import pywin.tools.browser,win32ui
            from pywin.framework.app import CreateDefaultGUI
            from pywin.framework.intpyapp import InteractivePythonApp
            #from pywin.tools.browser import Browse
        except ImportError,message:
            print 'ImportError: PythonWin (%s)'%message
            return
        class _PythonWinNoDDE(InteractivePythonApp):
            """No dde methods."""
            def InitDDE(self):
                pass
            def MakeExistingDDEConnection(self):
                pass
        stderr=sys.stderr
        stdout=sys.stdout
        self.fileList=fileList
        self.setStatusText=win32ui.SetStatusText
        sys.argv=[]

        CreateDefaultGUI(_PythonWinNoDDE)
        self.app=win32ui.GetApp()
        for b in browse:
            Browse(*b)
        for b in browseMDI:
            pywin.tools.browser.BrowseMDI(b)
        self.app.LoadUserModules(modules)
        fileList=self.getFileList()
        if fileName and fileName not in fileList:fileList.append(fileName)
        for f in fileList:self.app.OpenDocumentFile(f)
        self.editor=self.app.GetDocTemplateList()[1]
        self.interpretor=self.app.GetDocTemplateList()[0].GetDocumentList()[0]
        self.browser=pywin.tools.browser.template
        if onIdle:self.app.idleHandlers.append(onIdle)
        win32ui.StartDebuggerPump()
        sys.stderr=stderr
        sys.stdout=stdout

    def getFileList(self):
        """Can be overwritten."""
        return self.fileList

    def getDocumentList(self):
        """Returns a list of the currently opened documents."""
        return [x.GetPathName() for x in self.editor.GetDocumentList()]

    def onIdle(self):
        """Idle handler: To be overwritten."""
        pass

class PythonWinPreload(PythonWin):
    """PythonWin IDE which automatically opens file which were open during
    the last editing session."""
    def __init__(self,path,fileName=None,browse=[],browseMDI=[],modules='',statusText='Ready'):
        """path is the file with the file list."""
        self.path=path
        self.statusText=statusText
        PythonWin.__init__(self,fileName,browse=browse,browseMDI=browseMDI,modules=modules,onIdle=self.onIdle)

    def getFileList(self):
        """Loads file list from the path."""
        try:
            f=open(self.path,'r')
            fileList=eval(f.read())
            f.close()
            return fileList
        except:
            return []

    def onIdle(self,*arg,**keyw):
        """Save file list to the path."""
        newFileList=self.getDocumentList()
        if newFileList!=self.fileList:
            self.fileList=newFileList
            f=open(self.path,'w')
            f.write(str(self.fileList))
            f.close()
            self.setStatusText(self.statusText)