#!/usr/bin/env python
#Boa:App:BoaApp

# TODO: replace list controls with sortable list controls
import info
INFO=info.copy()
INFO['description']=\
"""This is the main spe application created in boa."""
__doc__=INFO['doc']%INFO


import os,sys
from wxPython.wx import *
from wxPython.help import *

print '\nStarting Spe v%s ...\n'%INFO['version']
print 'If spe fails to start:'
print '\t- type "python SPE_.py --debug" at the command prompt'
print '\t- send the error report to s_t_a_n_i@yahoo.com\n'
import framework.wxMDIParentFrame1 as wxMDIParentFrame1
PATH=os.path.dirname(wxMDIParentFrame1.__file__)


modules ={'BlenderTab': [0, '', 'framework/tabs/BlenderTab.py'],
 'BrowserTab': [0, '', 'framework/tabs/BrowserTab.py'],
 'Extra': [0, '', 'framework/menus/Extra.py'],
 'FindTab': [0, '', 'framework/tabs/FindTab.py'],
 'SPE_': [0, '', 'SPE_.pyw'],
 '__init__': [0, '', '__init__.py'],
 'about': [0, '', 'doc/about.txt'],
 'addYourOwnMenus': [0, '', 'doc/addYourOwnMenus.txt'],
 'build': [0, '', '../distributions/spe/build.py'],
 'dropTarget': [0, '', 'framework/dropTarget.py'],
 'help': [0, '', 'framework/help.py'],
 'helpDialog': [0, '', 'framework/dialogs/helpDialog.py'],
 'helpShortcutsDialog': [0, '', 'framework/dialogs/helpShortcutsDialog.py'],
 'info': [0, '', 'info.py'],
 'kiki': [0, '', 'framework/plugins/kiki/kiki.py'],
 'optionsDialog': [0, '', 'framework/dialogs/optionsDialog.py'],
 'osx': [0, '', '../sm/osx.py'],
 'parentInit': [0, '', 'framework/parentInit.py'],
 'python': [0, '', '../sm/python.py'],
 'readme': [0, '', 'doc/readme.txt'],
 'recent': [0, '', 'framework/recent.txt'],
 'remember': [0, '', 'framework/remember.txt'],
 'scriptutils': [0, '', '../sm/scriptutils.py'],
 'settings': [0, '', 'framework/settings.py'],
 'setup': [0, '', '../distributions/spe/setup.py'],
 'shell': [0, '', 'framework/shell.py'],
 'shortcuts': [0, '', 'framework/shortcuts.py'],
 'speDialog': [0, '', 'framework/dialogs/speDialog.py'],
 'spe_notes': [0, '', 'spe_notes.txt'],
 'splashScreen': [0, '', 'framework/dialogs/splashScreen.py'],
 'utils': [0, '', 'framework/utils.py'],
 'winInstall': [0, '', 'winInstall.py'],
 'winUninstall': [0, '', 'winUninstall.py'],
 'wxMDIChildFrame1': [0, '', 'framework/wxMDIChildFrame1.py'],
 'wxMDIParentFrame1': [1, '', 'framework/wxMDIParentFrame1.py'],
 'wxPyEdit': [0, '', '../sm/wxPyEdit.py'],
 'wxp': [0, '', '../sm/wxp.py']}

class MySplashScreen(wxSplashScreen):
    def __init__(self,app):
        bmp = wxImage(os.path.join(PATH,"images","spe.png")).ConvertToBitmap()
        wxSplashScreen.__init__(self, bmp,
                                wxSPLASH_CENTRE_ON_SCREEN|wxSPLASH_TIMEOUT,
                                3000, None, -1,
                                style = wxSIMPLE_BORDER|wxFRAME_NO_TASKBAR|wxSTAY_ON_TOP)
        EVT_CLOSE(self, self.OnClose)
        self.app=app

    def OnClose(self, evt):
        evt.Skip()  # Make sure the default handler runs too...

class BoaApp(wxApp):
    def __init__(self,*arg,**options):
        self.options=options
        wxApp.__init__(self,*arg)
    def OnInit(self):
        wxInitAllImageHandlers()
        splash = MySplashScreen(self)
        splash.Show()
        self.provider = wxSimpleHelpProvider()
        wxHelpProvider_Set(self.provider)
        self.main = wxMDIParentFrame1.create(None,splash=splash,**self.options)
        self.main.Show(true)
        self.SetTopWindow(self.main)
        return true

def main(tabs={},redraw=None,redirect=1,Blender=None,openFiles=[]):
    """
    redirect: if -1, default settings of settings.py
    """
    application = BoaApp(0,tabs=tabs,redraw=redraw,redirect=redirect,
        Blender=Blender,openFiles=openFiles)
    application.MainLoop()

def blenderMain():
    try:
        import wx
        wxV='.'.join([str(x)for x in wx.VERSION])
        if wxV!=INFO['wxVersion']:
            print '\nSpe Warning: Spe was developped on wxPython v%s, but v%s was found.'%(INFO['wxVersion'],wxV)
            print 'If you experience any problems please install wxPython v%s\n'%INFO['wxVersion']
    except:
        print "Spe Error: Please install the right version of wxPython: %s"%INFO['wxVersion']
    try:
        import Blender
        redraw=Blender.Redraw
    except:
        Blender=0
        redraw=None
    if 'argv' in dir(sys):
        commandLine=sys.argv[1:]
        redirect=('--debug' not in commandLine)
        openFiles=[x for x in commandLine if x[:2]!= '--']
    else:
        redirect=1
        openFiles=[]
    app=main(redraw=redraw,Blender=Blender,openFiles=openFiles,redirect=redirect)

if __name__=="__main__":
    blenderMain()