#(c)www.stani.be
import spe.info,sm
INFO=spe.info.copy()

INFO['description']=\
"""This is an example of how to create a custom menu. Copy this file and use it
as a template. Note that sortLines creates a toolbar button."""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

from __init__ import *
import string

#---menu functions------------------------------------------------------------
def count(script,app,event):
    """Count"""
    name=script.fileName
    text=script.source.GetText()
    app.message(_count(text,name))

def countSelection(script,app,event):
    """Count in selection"""
    name=script.fileName
    text=script.source.GetSelectedText()
    app.message(_count(text,'Selection of %s'%name))

def insertTime(script,app,event):
    """Insert time && date"""
    import time
    now = time.localtime(time.time())
    dateStr = time.strftime("%A, %B %d, %Y,  %I:%M %p", now)
    script.source.ReplaceSelection(dateStr)

def runExternalFile(script,app,event):
    """Run external file"""
    fileName=app.messageEntry('Enter filename:')
    if fileName:app.run(fileName)

def insertSeparator(script,app,event):
    """Insert Boa separator"""
    label=app.messageEntry('Enter label:')
    if label:
        separator='#---%s%s'%(label,sm.zfill('-',(76-len(label))).replace('0','-'))
        script.source.ReplaceSelection(separator)

def sortLines(script,app,event):
    """Sort selected lines with sort.png toolbar button"""
    text=script.source.GetSelectedText()
    lines=text.split('\n')
    lines.sort()
    text='\n'.join(lines)
    script.source.ReplaceSelection(text)
    app.SetStatus('Selection is sorted.')

#---helper functions------------------------------------------------------------
def _count(text,name):
    chars = len(text)
    words = len(text.split())
    lines = len(text.splitlines())
    return "%s contains:\n- %s char(s)\n- %s word(s)\n- %s line(s)"%\
        (name,chars,words,lines)

#---menu definition-------------------------------------------------------------
def main(app):
    menu(app,
        item(label='Count',action=count,toolbar=None),
        item(label='Count in selection',action=countSelection,toolbar=None),
        SEPARATOR,
        item(label='Insert time && date',action=insertTime,toolbar=None),
        item(label='Insert separator',action=insertSeparator,toolbar=None),
        item(label='Sort selected lines',action=sortLines,toolbar='sort.png'),
        SEPARATOR,
        item(label='Run external file',action=runExternalFile,toolbar=None),
    )
