#(c)www.stani.be
import spe.info
INFO=spe.info.copy()

INFO['description']=\
"""This script is a part of wxMDIParentFrame1.py, so that file doesn't get too
big."""

__doc__=INFO['doc']%INFO
#---import modules--------------------------------------------------------------

#general
import os,sys,time, ConfigParser
import sm.wxp

#wxPython
import wx
from wx.py.filling import Filling
from wx.py.crust import SessionListing

#spe specific
import dropTarget,help
from shell import Shell
from tabs import BrowserTab, BlenderTab, FindTab

#---Constants-------------------------------------------------------------------
FOLDERS='folders.txt'
NOTES='notes.txt'
PATH=os.path.dirname(dropTarget.__file__)
RECENT='recent.txt'
REMEMBER='remember.txt'
SETTINGS_DEFAULT={
    'File open: convert tabs to spaces':4,
    'File save: check syntax':1,
    'File save: strip trailing spaces':1,
    'System: redirect output to Shell':1,
    'System: maximum amount recent files':100,
    'System: redraw interval in seconds':1
}
if sys.platform=='win32':
    LIST_STYLE=wx.LC_LIST|wx.LC_SMALL_ICON
else:
    LIST_STYLE=wx.LC_LIST

try:
    os.mkdir(INFO['userPath'])
except:
    pass
#---overwrite wxBitmap for absolute paths---------------------------------------
wx._wxBitmap=wx.Bitmap
def wxBitmap(name,*args,**options):
    """Overwriting to change relative in absolute path"""
    return wx._wxBitmap(os.path.join(PATH,'..',name),*args,**options)

SEPERATOR=None
wx_wxMenuAppend=wx.Menu.Append
def wxMenuAppend(self,id=SEPERATOR,*args,**options):
    if id==SEPERATOR:return self.AppendSeparator()
    else:return wx_wxMenuAppend(self,id,*args,**options)
#---parent private initializers for unsupported boa modules---------------------
def icons(self):
    self.iconsList=wx.ImageList(16,16)
    self.icons={}
    self.iconsListIndex={}
    imagePath=os.path.join(self.path,'images')
    iconFiles=os.listdir(imagePath)
    iconFiles.sort()
    for icon in iconFiles:
        if os.path.splitext(icon)[-1] in ['.png']:
            self.icons[icon]=wxBitmap(os.path.join('framework','images',icon),wx.BITMAP_TYPE_PNG)
            if self.icons[icon].GetHeight() < 20:
                self.iconsListIndex[icon]=self.iconsList.Add(self.icons[icon])

wxID_TOOLSWINDOWSCONSOLE = wx.NewId()
wxID_TOOLSWINDOWSRUN     = wx.NewId()
wxID_TOOLSWINDOWSRUNEXIT = wx.NewId()

def importMenus(self):
    print 'Importing user menus...'
    menus=sm.osx.listdirR(os.path.join(self.path,'menus'),extensions=['.py'],absolute=0)
    menus.remove('__init__.py')
    menus.sort()
    menus.reverse()
    menuDict={}
    userEvents=[]

    import sys
    sys.path.insert(0,os.path.join(self.path,'menus'))
    for menu in menus:
        menuLabel=os.path.splitext(menu)[0]
        try:
            codeObj = compile('import '+menuLabel,'<auto import>','exec')
            exec codeObj in menuDict
            menuModule=menuDict[menuLabel]
            menuModule.main(self)
            userEvents.extend(menuModule.events)
            if menuModule.userMenu[-1] and menuModule.labels:
                self.menuBar1.Insert(5,menu=menuModule.userMenu[-1], title=menuLabel)
                print '\t%s (OK)'%(menuLabel)
            else: print '\t%s (FAILED:no items?!)'%menuLabel
        except Exception,message:
            print '\t%s (FAILED:%s)'%(menuLabel,message)
    del sys.path[0]
    self.toolBar.Realize()

    if sys.platform=='win32':
        self.menuTools.Append(id=-1, item='')
        self.menuTools.Append(helpString='', id=wxID_TOOLSWINDOWSCONSOLE,
              item='Open windows console\tAlt+F9', kind=wx.ITEM_NORMAL)
        self.menuTools.Append(helpString='', id=wxID_TOOLSWINDOWSRUN,
              item='Run in windows console\tCtrl+F9', kind=wx.ITEM_NORMAL)
        self.menuTools.Append(helpString='', id=wxID_TOOLSWINDOWSRUNEXIT,
              item='Run in windows console && exit\tCtrl+Alt+F9', kind=wx.ITEM_NORMAL)
        wx.EVT_MENU(self, wxID_TOOLSWINDOWSCONSOLE, self.menuToolsConsole)
        wx.EVT_MENU(self, wxID_TOOLSWINDOWSRUN,     self.menuToolsRunExternal)
        wx.EVT_MENU(self, wxID_TOOLSWINDOWSRUNEXIT, self.menuToolsRunExternalExit)

def fileDrop(self):
    self.SetDropTarget(dropTarget.FileParentOpen(self.open))

def redirect(self):
    if self.settings['System: redirect output to Shell']:
        self.shell.redirectStdin(1)
        self.shell.redirectStdout(1)
        self.shell.redirectStderr(1)

def sashLayoutWindow1(self, tabs={}):
    """Create sashLayoutWindow1 contents."""
    print 'Creating tabs...'
    #varia
    self.title='Spe'
    #arrange layout
    self.box1 = wx.BoxSizer(wx.VERTICAL)
    self.box1.Add(self.notebook1, 1, wx.ALL | wx.EXPAND, 0)
    self.sashLayoutWindow1.SetAutoLayout(wx.true)
    self.sashLayoutWindow1.SetSizer(self.box1)
    #shell
    print '\tShell'
    self.shell=Shell(parent=self.notebook1, introText=\
"""Portions Copyright 2003 www.stani.be - see credits in manual for further copyright information.
Press Shift+Delete,Alt+C & Alt+V for Cut, Copy & Paste. Double click to jump to error source code.""")
    self.shell.setStatusText=self.SetStatus
    self.shell.open=self.open
    self.shell.interp.push('namespace={}')
    self.shell.SetDropTarget(dropTarget.FileShellRun(self.run))
    self.shell.SetHelpText(help.shell)
    self.notebook1.AddPage(page=self.shell, text='Shell')
    #namespace
    print '\tLocals'
    self.namespace = sm.wxp.SmFilling(parent=self.notebook1,
                           rootObject=self.shell.interp.locals,
                           rootLabel='locals()',
                           rootIsNamespace=1)
    self.namespace.tree.setStatusText=self.SetStatus
    self.namespace.SetHelpText(help.namespace)
    self.notebook1.AddPage(page=self.namespace, text='Locals')
    #custom tabs (dictionnary of rootObjects)
    tabKeys=tabs.keys()
    tabKeys.sort()
    for tab in tabKeys:
        tabItem=tabs[tab]
        if type(tabs[tab]).__name__ in ['tuple','list']:
            tabObject=tabItem[0]
            tabWelcome=tabItem[1]
            if len(tabItem)>2:tabLabel=tabItem[2]
            else:tabLabel='Ingredients'
        else:
            tabObject=tabItem
            tabWelcome=""
            tabLabel='Ingredients'
        tabFilling=sm.wxp.SmFilling(parent=self.notebook,
                                   rootObject=tabObject,
                                   rootLabel=tabLabel,
                                   rootIsNamespace=0,
                                   welcome=tabWelcome
                                 )
        self.notebook.AddPage(page=tabFilling, text=tab, select=0)
    #session
    print '\tSession'
    self.sessionlisting = SessionListing(parent=self.notebook1)
    self.sessionlisting.SetHelpText(help.session)
    self.notebook1.AddPage(page=self.sessionlisting, text='Session')
    #finder
    print '\tFind'
    self.finder = FindTab.Panel(self.notebook1,-1,bitmap=wxBitmap,mdi=self)
    self.finder.SetHelpText(help.finder)
    self.notebook1.AddPage(page=self.finder, text='Find')
    #browser
    print '\tBrowser'
    self.browser = BrowserTab.create(self.notebook1,bitmap=wxBitmap,mdi=self)
    self.browser.SetDropTarget(dropTarget.FileBrowserAdd(self.browser.add))
    self.browser.SetHelpText(help.browser)
    self.notebook1.AddPage(page=self.browser, text='Browser')
    #recent
    print '\tRecent'
    self.recent = wx.ListCtrl(parent=self.notebook1,style=LIST_STYLE)
    self.recentImageList=wx.ImageList(16,16)
    self.pyIcon=self.recentImageList.Add(self.icons['source_py.png'])
    self.recent.SetImageList(self.recentImageList,wx.IMAGE_LIST_SMALL)
    self.recent.SetDropTarget(dropTarget.FileRecentAdd(self.recentAdd))
    self.recent.SetHelpText(help.recent)
    self.notebook1.AddPage(page=self.recent, text='Recent')
    wx.EVT_LIST_ITEM_SELECTED(self.recent,self.recent.GetId(),
            self.eventRecentOpen)
    wx.EVT_LIST_ITEM_RIGHT_CLICK(self.recent,self.recent.GetId(),
            self.OnRecentRightClick)
    wx.EVT_LIST_ITEM_MIDDLE_CLICK(self.recent,self.recent.GetId(),
            self.OnRecentMiddleClick)
    #todo
    print '\tTodo'
    self.todo = wx.ListCtrl(parent=self.notebook1,style=wx.LC_REPORT)
    self.todo.InsertColumn(col=0, format=wx.LIST_FORMAT_LEFT,
            heading='File',width=120)
    self.todo.InsertColumn(col=1, format=wx.LIST_FORMAT_LEFT,
            heading='Line',width=40)
    self.todo.InsertColumn(col=2, format=wx.LIST_FORMAT_LEFT,
            heading='!',width=20)
    self.todo.InsertColumn(col=3, format=wx.LIST_FORMAT_LEFT,
            heading='Task',width=500)
    self.notebook1.AddPage(page=self.todo, text='Todo')
    self.todo.SetHelpText(help.todo)
    wx.EVT_LIST_ITEM_SELECTED(self.todo,self.todo.GetId(),
            self.eventTodoJump)
    #index
    print '\tIndex'
    self.index = wx.ListCtrl(parent=self.notebook1,style=LIST_STYLE)
    self.index.SetImageList(self.iconsList,wx.IMAGE_LIST_SMALL)
    self.notebook1.AddPage(page=self.index, text='Index')
    self.index.SetHelpText(help.index)
    wx.EVT_LIST_ITEM_SELECTED(self.index,self.index.GetId(),
            self.eventIndexJump)
    #notes
    print '\tNotes'
    self.notes = wx.TextCtrl(self.notebook1,-1,style=wx.TE_MULTILINE|wx.TE_DONTWRAP)
    self.notes.SetHelpText(help.notes)
    self.notebook1.AddPage(page=self.notes, text='Notes')
    #blender
    print '\tBlender'
    self.blender = BlenderTab.create(self.notebook1,bitmap=wxBitmap,Blender=self.Blender)
    self.blender.SetHelpText(help.blender)
    self.notebook1.AddPage(page=self.blender, text='Blender')
    #notebook images
    self.notebook1.AssignImageList(self.iconsList)
    self.notebook1.SetPageImage(0, self.iconsListIndex['pyCrust_small.png'])
    self.notebook1.SetPageImage(1, self.iconsListIndex['view_tree.png'])
    self.notebook1.SetPageImage(2, self.iconsListIndex['shellscript.png'])
    self.notebook1.SetPageImage(3, self.iconsListIndex['find.png'])
    self.notebook1.SetPageImage(4, self.iconsListIndex['browse.png'])
    self.notebook1.SetPageImage(5, self.iconsListIndex['history.png'])
    self.notebook1.SetPageImage(6, self.iconsListIndex['todo.png'])
    self.notebook1.SetPageImage(7, self.iconsListIndex['contents2.png'])
    self.notebook1.SetPageImage(8, self.iconsListIndex['xedit.png'])
    self.notebook1.SetPageImage(9, self.iconsListIndex['blender.png'])

def settings(self,redraw=None,Blender=None,redirect=-1):
    self.children=[]
    self.folders=[]
    self.path=PATH
    self.remember=0
    self.findDialog=None
    self.dead=None
    self.kiki=None

    self.redraw=redraw
    self.Blender=Blender


    self.settings={}
    try:
        import settings.settings as userSettings
        userSettingsNames=userSettings.keys()
        for name in SETTINGS_DEFAULT.keys():
            if name in userSettingsNames:
                self.settings[name]=userSettings[name]
            else:
                self.settings[name]=SETTINGS_DEFAULT[name]
    except:
        self.settings=SETTINGS_DEFAULT
    try:
        f=open(os.path.join(self.path,'settings.py'),'w')
        f.write('settings='+pprint.pformat(self.settings))
        f.close
    except:
        pass
    if redirect!=-1:
        self.settings['System: redirect output to Shell']=redirect

wxID_TOOLBARHELP=wx.NewId()

def toolbarSeparators(self):
    self.toolBar.InsertSeparator(7)
    self.toolBar.InsertSeparator(10)
    self.toolBar.InsertSeparator(14)
    self.toolBar.InsertSeparator(19)
    self.toolBar.InsertSeparator(23)
    self.toolBar.InsertSeparator(27)
    self.toolBar.InsertSeparator(33)
    self.toolBar.AddSeparator()
##    self.toolBar.AddTool(bitmap=wxBitmap('framework/images/help.png',
##          wx.BITMAP_TYPE_PNG), id=wxID_TOOLBARHELP, isToggle=wx.false,
##          longHelpString='', pushedBitmap=wx.NullBitmap,
##          shortHelpString='Context Help')
##    wx.EVT_TOOL(self, wxID_TOOLBARHELP, self.contextHelp)
    self.toolBar.Realize()

def findReplaceEvents(self):
    self.findStr=''
    self.replaceStr=''
    self.findFlags=1
    self.stcFindFlags=0
    wx.EVT_COMMAND_FIND(self, -1, self.eventFind)
    wx.EVT_COMMAND_FIND_NEXT(self, -1, self.eventFind)
    wx.EVT_COMMAND_FIND_REPLACE(self, -1, self.eventReplace)
    wx.EVT_COMMAND_FIND_REPLACE_ALL(self, -1, self.eventReplaceAll)
    wx.EVT_COMMAND_FIND_CLOSE(self, -1, self.eventFindClose)

def remember(self,openFiles=[]):
    global RECENT,FOLDERS,NOTES,REMEMBER

    self.recentFiles=[]
    try:
        files=eval(self.openUser(RECENT))
        self.recentAdd([file for file in files if file and os.path.exists(file)])
    except:
        pass

    try:
        folders=eval(self.openUser(FOLDERS))
        self.browser.slider1.SetValue(folders[0])
        self.browser.add([file for file in folders[1:] if file])
    except:
        pass

    try:
        notes=self.openUser(NOTES)
        self.notes.SetValue(notes)
    except:
        pass

    fileList=[]
    try:
        files=eval(self.openUser(REMEMBER))
        fileList=[file for file in files if file]
        f.close()
    except:
        pass
    fileList.extend(openFiles)
    if fileList:
        self.rememberSet(1)
        self.open(fileList,message=0,select=None)
    else:
        self.rememberSet(0)
        self.new()
    self.eventSideBarStatus(None)

