#(c)www.stani.be
import spe.info
INFO=spe.info.copy()

INFO['description']=\
"""Subclassing the py(crust) shell to be able to jump to the source code after
an error occured."""

__doc__=INFO['doc']%INFO
import wx,re
from wx import py

class Shell(py.shell.Shell):
    def __init__(self,**keyw):
        py.shell.Shell.__init__(self,**keyw)
        wx.EVT_LEFT_DCLICK(self,self.jumpToSource)

    def jumpToSource(self,event=None):
        line=self.GetCurrentLine()
        text=None
        while not text and line>0:
            text=self.GetLine(line)
            if text.find('File')!=-1 and text.find('line')!=-1:
                text='{%s}'%text.split('in ')[0].strip().replace('File','"file":').replace('line','"line":')
                try:
                    text=eval(text)
                except:
                    text=None
            else: text=None
            line-=1

        #pyChecker support by Nicodemus
        if not text:
            # check if the line in the form filename:line: message
            current_line = self.GetLine(self.GetCurrentLine())
            m = re.match('(.*):(\d+): .*', current_line)
            if m:
                text = {}
                text['file'] = m.group(1)
                text['line'] = int(m.group(2))+1
            else:
                text = None

        if text:
            text['line']-=1
            self.open(text['file'],text['line'])
            self.setStatusText('Jumped to file "%s" (line %s)'%(text['file'],text['line']))
        else:
            self.setStatusText('Error: Impossible to locate file and line number.')

    def OnKeyDown(self, event):
        """Overwriting Key down event handler to allow cut,copy,paste with alt."""

        # If the auto-complete window is up let it do its thing.
        if self.AutoCompActive():
            event.Skip()
            return
        key = event.KeyCode()
        control = event.ControlDown()
        alt = event.AltDown()
        shift = event.ShiftDown()
        if key==wx.WXK_SPACE and control:
            self.jumpToSource(event)
        elif (alt and key in (ord('C'), ord('c'))):
            self.Copy()
        elif (alt and key in (ord('V'), ord('v'))):
            self.Paste()
        else:py.shell.Shell.OnKeyDown(self,event)